package volatileprototypes.Panel4P;

import java.awt.*;
import java.awt.geom.Line2D;
import javax.swing.*;
import java.util.ArrayList;
import java.lang.reflect.*;

//
// Generic Component Class
//
public class Component implements PanelStyles {
    Panel4P canvas;
    int x, y, w, h, spacing;
    String name;
    float value = 0;
    Method trigger;
    Field field;
    
    Component(Panel4P nCanvas) {
        canvas = nCanvas;
		x = 4;
		y = 0;
		w = canvas.width - 10;
		h = 30;
		spacing = 6;
    }
    
    void rdraw() {}

    void checkForPressed() {}
    
    void checkForReleased() {}
    
    void checkForDrag() {}
    
    int updateY(int yin) {
		y = yin;
		return(y + h + spacing);
    }
    
    final Component setTrigger(Method tin) {
    	trigger = tin;
    	return(this);
    }
    
    final Component setField(Field fin) {
    	field=fin;
    	return(this);
    }
	
	private void setShade(float shade) {
		int s = (int)shade;
		Color r = new Color(s, s, s);
		canvas.g2.setColor(r);
	}
	
	private void setFont(boolean bold) {
		Font  font;
		if (bold) {
			font = new Font("Arial", Font.BOLD, 11);
		} else {
			font = new Font("Arial", Font.PLAIN, 11);
		}
		canvas.g2.setFont(font);
	}
	
	final void line(double x1, double y1, double x2, double y2, float shade) {
		Point lineStart = new Point((int)x1, (int)y1);
        Point lineEnd = new Point((int)x2, (int)y2);
		Line2D line = new Line2D.Double(lineStart, lineEnd);
		setShade(shade);
		canvas.g2.draw(line);
	}
	
	final void line(double x1, double y1, double x2, double y2) {
		line(x1, y1, x2, y2, strok);
	}
	
    final void drawGradient(int x, int y, int w, float h, int color1, int color2) {
		canvas.g2.setStroke(normalStroke);
		for (float i=1; i<h; i++) {
			float r = i / h;
			float diff = color2 - color1;
			line(x + 1, y + i, x + w - 1, y + i, color1 + r * diff);//lerp
		}
    }

    final void drawEnclosure(int x, int y, int w, int h) {
		line(x + 2, y,x + w - 2, y);
		line(x + 2, y + h, x + w - 2, y + h);
		line(x, y + 2, x, y + h - 2);
		line(x + w, y + 2, x + w, y + h - 2);
		line(x, y + 2, x + 2, y);
		line(x + w - 2, y, x + w, y + 2);
		line(x + w - 2, y + h, x + w, y + h - 2);
		line(x, y + h - 2, x + 2, y + h);
    }
    
    final void drawHLine(int y) {
		line(x, y, x + w, y);
    }
    
    final void drawVLine(int x, int y1, int y2) {
		line(x, y1, x, y2);
    }
    
    final void drawBoldText(String s, int x, int y, int nFill) {
		setFont(true);
		setShade(nFill);
		canvas.g2.drawString(s, x, y);
    }
	
	final void drawBoldTextWithShadow(String s, int x, int y, int nFill, int nShadow) {
		setFont(true);
		setShade(nShadow);
		canvas.g2.drawString(s, x, y + 1);
		setShade(nFill);
		canvas.g2.drawString(s, x, y);
	}
    
    final void drawLeftText(String s, int x, int y, int nFill) {
		setFont(false);
		setShade(nFill);
		canvas.g2.drawString(s, x, y);
    }
    
    final void drawRightText(String s, int x, int y, int nFill) {
		setFont(false);
		FontMetrics metrics = canvas.g2.getFontMetrics();
		int w = metrics.stringWidth(s);
		setShade(nFill);
		canvas.g2.drawString(s, x - w, y);
    }
    
    final boolean checkCollision() {
		float mx = canvas.mouseX;
		float my = canvas.mouseY - canvas.yOffset;
		if (x < mx && x + w > mx && y < my && y + h > my) {
			return(true);
		}
		return(false);
    }
    
    final boolean checkCollision(int x,int y, int w, int h) {
		float mx = canvas.mouseX;
		float my = canvas.mouseY - canvas.yOffset;
		if (x < mx && x + w > mx && y < my && y + h > my) {
			return(true);
		}
		return(false);
    }
  }